<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="红包状态" prop="redStatus">
        <el-select v-model="queryParams.redStatus" placeholder="请选择红包状态" clearable size="small">
          <el-option v-for="(item,index) in redStatusOptions" :key="item.dictValue+index" :label="item.dictLabel" :value="item.dictValue" />
        </el-select>
      </el-form-item>
      <el-form-item label="红包类型" prop="redType">
        <el-select v-model="queryParams.redType" placeholder="请选择红包类型" clearable size="small">
          <el-option v-for="(item,index) in redTypeOptions" :key="item.dictValue+index" :label="item.dictLabel" :value="item.dictValue" />
        </el-select>
      </el-form-item>
      <el-form-item label="直播间ID" prop="liveId" >
        <el-input
          v-model="queryParams.liveId"
          placeholder="请输入直播间ID"
          clearable
          size="small"
          :disabled="canLiveId"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="红包标题" prop="desc">
        <el-input
          v-model="queryParams.desc"
          placeholder="请输入描述"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建日期" prop="createTime">
        <el-date-picker clearable size="small"
          v-model="queryParams.createTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择创建日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="修改日期" prop="updateTime">
        <el-date-picker clearable size="small"
          v-model="queryParams.updateTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择修改日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['live:liveRedConf:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['live:liveRedConf:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['live:liveRedConf:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="liveRedConfList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="红包ID" align="center" prop="redId" />
      <el-table-column label="红包状态" align="center" prop="redStatus" :formatter="redStatusFormatter"/>
      <el-table-column label="有效时间 单位：分" align="center" prop="duration" />
      <el-table-column label="红包类型" align="center" prop="redType" :formatter="redTypeFormatter"/>
      <el-table-column label="直播间ID" align="center" prop="liveId" />
      <el-table-column label="芳华币数量" align="center" prop="redNum" />
      <el-table-column label="可中奖份量" align="center" prop="totalLots" />
      <el-table-column label="实际发放奖励份量" align="center" prop="totalSend" />
      <el-table-column label="红包标题" align="center" prop="desc" />
      <el-table-column label="创建日期" align="center" prop="createTime" width="120">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="修改日期" align="center" prop="updateTime" width="120">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['live:liveRedConf:edit']"
            style="margin-left: 10px"
          >修改</el-button>
          <!-- 开始 -->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleStatusChange(scope.row,'1')"
            v-hasPermi="['live:liveRedConf:edit']"
          >开始</el-button>
          <!-- 暂停 -->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleStatusChange(scope.row,'3')"
            v-hasPermi="['live:liveRedConf:edit']"
          >暂停</el-button>
          <!-- 结算 -->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleStatusChange(scope.row,'2')"
            v-hasPermi="['live:liveRedConf:edit']"
          >结算</el-button>

          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['live:liveRedConf:edit']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改直播红包记录配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="持续时间" prop="duration">
          <el-input v-model="form.duration" placeholder="请输入红包有效时间 单位：分" />
        </el-form-item>
<!--        <el-form-item label="红包类型" prop="redType">
          <el-select v-model="form.redType" placeholder="请选择红包类型">
            <el-option v-for="(item,index) in redTypeOptions" :key="item.dictValue+index" :label="item.dictLabel" :value="item.dictValue" />
          </el-select>
        </el-form-item>-->
        <el-form-item label="直播间ID" prop="liveId">
          <el-input v-model="form.liveId" placeholder="请输入直播间ID" :disabled="canLiveId"/>
        </el-form-item>
        <el-form-item label="芳华币数" prop="redNum">
          <el-input v-model="form.redNum" placeholder="请输入芳华币数量" />
        </el-form-item>
        <el-form-item label="中奖份量" prop="totalLots">
          <el-input v-model="form.totalLots" placeholder="请输入可中奖份量" />
        </el-form-item>
        <el-form-item label="红包标题" prop="desc">
          <el-input v-model="form.desc" placeholder="请输入红包描述" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listLiveRedConf, getLiveRedConf, delLiveRedConf, addLiveRedConf, updateLiveRedConf, exportLiveRedConf } from "@/api/live/liveRedConf";

export default {
  name: "LiveRedConf",
  data() {
    return {
      //字典
      redStatusOptions: [],
      redTypeOptions: [],
      canLiveId:false,
      //parentLiveId
      parentLiveId : null,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 直播红包记录配置表格数据
      liveRedConfList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        redStatus: null,
        redType: null,
        liveId: null,
        desc: null,
        createTime: null,
        updateTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        duration: [
          { required: true, message: "有效时间 单位：分不能为空", trigger: "blur" }
        ],
        /* redType: [
          { required: true, message: "红包类型不能为空", trigger: "change" }
        ], */
        liveId: [
          { required: true, message: "直播间ID不能为空", trigger: "blur" }
        ],
        redNum: [
          { required: true, message: "芳华币数量不能为空", trigger: "blur" }
        ],
        totalLots: [
          { required: true, message: "可中奖份量不能为空", trigger: "blur" }
        ],
        desc: [
          { required: true, message: "描述不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getDicts("sys_live_red_status").then(response => {
      this.redStatusOptions = response.data;
    });
    this.getDicts("sys_live_red_type").then(response => {
      this.redTypeOptions = response.data;
    });
    this.parentLiveId = this.liveId;
    this.queryParams.liveId = this.parentLiveId;
    if(this.queryParams.liveId){
      this.form.liveId = this.parentLiveId;
      //设置查询条件直播间ID不可修改
      this.canLiveId = true;
    }
    this.getList();
  },
  computed: {
    liveId() {
      return this.$route.params.liveId;
    }
  },
  methods: {
    handleStatusChange(row, status) {
      //结束的抽奖不能进行操作
      if(row.redStatus+"" === "2"){
        this.msgError("已结束的红包不能进行操作");
        return;
      }
      switch (status+"") {
        case "1":
          //只能对未开启的抽奖进行操作
          if(row.redStatus+"" !== "0" && row.redStatus+"" !== "3"){
            this.msgError("只能对未开启或暂停的红包进行开始操作");
            return;
          }
          break;
        case "2":
          //只能对进行中或暂停的红包进行结算
          if(row.redStatus+"" !== "1" && row.redStatus+"" !== "3"){
            this.msgError("只能对进行中或暂停的红包进行结算");
            return;
          }
          break;
        case "3":
          //只能对进行中的抽奖执行暂停操作
          if(row.redStatus+"" !== "1"){
            this.msgError("只能对进行中的红包执行暂停操作");
            return;
          }
          break;
        default:
          return;
      }
      const doRedParam = {
        redId: row.redId,
        redStatus: status
      };
      updateLiveRedConf(doRedParam).then(response => {
        if(response.code === 200){
          this.$store.state.liveWs[this.liveId].sendWs("red",response.msg, row.redId,this.liveId);
          this.getList();
          this.msgSuccess("修改成功");
        }else{
          this.msgError(response.msg);
        }
        this.open = false;
      });
    },
    redStatusFormatter(row, column) {
      return this.selectDictLabel(this.redStatusOptions, row.redStatus);
    },
    redTypeFormatter(row, column) {
      return this.selectDictLabel(this.redTypeOptions, row.redType);
    },
    /** 查询直播红包记录配置列表 */
    getList() {
      this.loading = true;
      listLiveRedConf(this.queryParams).then(response => {
        this.liveRedConfList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        redId: null,
        redStatus: null,
        duration: null,
        //redType: null,
        liveId: null,
        redNum: null,
        totalLots: null,
        totalSend: null,
        desc: null,
        createTime: null,
        updateTime: null,
        createBy: null,
        updateBy: null
      };
      this.resetForm("form");
      this.checkParentLiveId();
    },
    //判断父页面传入参数
    checkParentLiveId(){
      if(this.parentLiveId){
        this.form.liveId = this.parentLiveId;
        this.queryParams.liveId = this.parentLiveId;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.checkParentLiveId();
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.redId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加直播红包记录配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      //只能对未开始或暂停的抽奖进行修改
      if(row.redStatus+"" !== "0" && row.redStatus+"" !== "3"){
        this.msgError("只能对未开始或暂停的红包进行修改");
        return;
      }
      this.reset();
      const redId = row.redId || this.ids
      getLiveRedConf(redId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改直播红包记录配置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.redId != null) {
            updateLiveRedConf(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            this.form.redType = 1;
            addLiveRedConf(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      //如果状态不为0，则不能删除
      if (row.redStatus+"" !== "0") {
        this.msgError("只能删除未发放的红包");
        return;
      }
      const redIds = row.redId || this.ids;
      this.$confirm('是否确认删除直播红包记录配置编号为"' + redIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delLiveRedConf(redIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有直播红包记录配置数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportLiveRedConf(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
